/*
 * $Id: adsi.js,v 1.113.4.23 2006/09/07 00:44:31 cmvc Exp $
 *
 * Copyright 2006 Collation Inc. All Rights Reserved
 *
 * This software is the proprietary information of Collation Inc.
 * Use is subject to license terms.
 */

function println(s) {
    if (s == undefined) {
        s = "";
    }
    var s = "" + s; // convert non-Strings to Strings (including null)
    WScript.StdOut.WriteLine(s);
}

function error(s) {
    println("!!! " + s);
}

function enumerate(collection) {
    results = new Array();
    e = new Enumerator(collection);
    for(i = 0; ! e.atEnd(); e.moveNext(), i++) {
        results.push(e.item());
    }
    return results;
}

function adsienum(path, keyType) {
    o = GetObject(path);
    if (keyType == "." || o.KeyType == keyType) {
        println(path);
    }
    var children = enumerate(o);
    for (child in children) {
        adsienum(children[child].AdsPath, keyType);
    }
}

function adsidump(path) {
    o = GetObject(path);
    cls = GetObject(o.Schema);
    var properties = new VBArray(cls.OptionalProperties).toArray();
    for (var p in properties) {
        prop = properties[p];
        println(prop + ": " + o[prop]);
    }
}

function usage() {
    error("usage (to list properties of all children): adsi <url>");
    error("e.g. IIS://localhost/W3SVC");
    error("e.g. IIS://localhost/W3SVC/1/ROOT");
    error("");
    error("usage (to recursively enumerate nodes of given type): adsi <url> <type>");
    error("e.g. IIS://localhost/W3SVC IIsWebServer");
    error("e.g. IIS://localhost/W3SVC/1/ROOT IIsWebVirtualDir");
    WScript.Quit(1);
}

var args = WScript.arguments;
if (args.length == 1) {
    path = args.item(0);
    adsidump(path);
} else if (args.length == 2) {
    path = args.item(0);
    keyType = args.item(1);
    adsienum(path, keyType);
} else {
    usage();
}
WScript.Quit(0);
